import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Enumeration;
import java.io.*;
import javax.sound.sampled.*;

import java.net.URL;
import java.net.MalformedURLException;
import  java.net.URLDecoder;

import sound.*;
import wavelet.*;
import utilities.WavRoutines;

/**
   CapturePlaybackApplet
 *
 * @version @(#)CapturePlaybackApplet.java	1.11	02/02/12
 * @author Reynald Hoskinson
 */
public class CapturePlaybackApplet extends JApplet
{
    static final boolean DEBUG = false;
    String wavfile = 
	"sounds/marsh_tree_frogs.wav";

    public static void showInfoDialog() {
        final String msg = 
            "When running Natural Grains as an applet these permissions\n" +
            "are necessary in order to load/save files and record audio :  \n\n"+
            "grant { \n" +
            "  permission java.io.FilePermission \"<<ALL FILES>>\", \"read, write\";\n" +
            "  permission javax.sound.sampled.AudioPermission \"record\"; \n" +
            "  permission java.util.PropertyPermission \"user.dir\", \"read\";\n"+
            "}; \n\n" +
            "The permissions need to be added to the .java.policy file.";
        new Thread(new Runnable() {
            public void run() {
                JOptionPane.showMessageDialog(null, msg, "Applet Info", JOptionPane.INFORMATION_MESSAGE);
            }
        }).start();
    }

    /**
     * initialize segmentation window
     */
    public void init() {
	if (DEBUG) {
	    System.out.println("start init");
	}
        CapturePlayback capturePlayback = new CapturePlayback();
	capturePlayback.init(); 

	// load default sound file listed on webpage
        URL codebase = getCodeBase();
	if (DEBUG) {
	    wavfile = getParameter("wavfile");
	    System.out.println("codebase: " + codebase);	
	}
        URL wavurl = null;
        try {
            wavurl = new URL(codebase,wavfile);
        } catch(MalformedURLException e) {
            System.out.println(e+" Malformed URL: " +codebase+" "+ wavfile);
        }
	capturePlayback.createAudioSample(wavurl);
	setContentPane(capturePlayback);
	validate();
	//  capturePlayback.show();
	if (DEBUG) {
	    System.out.println("finished init");
	}
    }
    public void start() {
    }
    public void stop() {
    }
}
