package sound;
import java.io.*;
import java.net.URL;
/**
 * data class to hold config parameters
 */

public class ConfigParams 
{
    float gainStart, gainMid, gainEnd;
    float panStart, panMid, panEnd;
    String soundFileName; 
    URL soundURL; 
    int threshSlider; 
    int noiseSlider;
    int wavFilter;

    float duration, durVar;
    
    float trigger, trigVar; // trigger every x seconds
    boolean segmented;
    boolean randWalk;
    
    public ConfigParams(
			float gainStart, float gainMid,float gainEnd,
			float panStart, float panMid, float panEnd,
			String soundFileName, 
			boolean segged,
			int threshSlider, 
			int noiseSlider,
			int wavFilter,
			float trigger,
			float trigVar,
			float duration,
			float durVar,
			boolean randWalk)
    {
	setParams(gainStart, gainMid, gainEnd,
		  panStart, panMid, panEnd,
		  soundFileName, 
		  segged,
		  threshSlider, 
		  noiseSlider,
		  wavFilter,
		  trigger,
		  trigVar,
		  duration,
		  durVar, 
		  randWalk);
    }

    public ConfigParams() 
    {
	panStart = 0.5F;
	panMid = 0.5F;
	panEnd = 0.5F;

	gainStart = 0.75F;
	gainMid = 0.5F;
	gainEnd = 0.75F;
	
	soundFileName = null;
	segmented = false;
	threshSlider = 25;
	noiseSlider = 2;
	wavFilter = 10;

	duration = 10;
	durVar = 0;
	trigger = 10;
	trigVar = 0;
	
	randWalk = false;

    }
    
    public void setParams(
			  float gainStart,float gainMid,  float gainEnd,
			  float panStart, float panMid, float panEnd,
			  String soundFileName, 
			  boolean segged,
			  int threshSlider, 
			  int noiseSlider,
			  int wavFilter,
			  float trigger,
			  float trigVar,
			  float duration,
			  float durVar, 
			  boolean randWalk)
    {
	this.gainStart = gainStart;
	this.gainMid = gainMid;
	this.gainEnd = gainEnd;
	this.panStart = panStart;
	this.panMid = panMid;
	this.panEnd = panEnd;
	this.soundFileName = soundFileName;
	this.segmented = segged;
	this.threshSlider = threshSlider;
	this.noiseSlider = noiseSlider;
	this.wavFilter = wavFilter;

	this.trigger = trigger;
	this.trigVar = trigVar;
	this.duration = duration;
	this.durVar = durVar;
	this.randWalk = randWalk;
	// System.out.println(soundFileName + " " + this.soundFileName);
    }

    public void setParams(
			  float gainStart, float gainMid, float gainEnd,
			  float panStart, float panMid, float panEnd,
			  float trigger, float trigVar,
			  float duration, float durVar)
    {
	this.gainStart = gainStart;
	this.gainMid = gainMid;
	this.gainEnd = gainEnd;
	this.panStart = panStart;
	this.panMid = panMid;
	this.panEnd = panEnd;

	this.trigger = trigger;
	this.trigVar = trigVar;
	this.duration = duration;
	this.durVar = durVar;
	this.randWalk = randWalk;
    }


    public void printParams(PrintWriter pw) 
    {
	// System.out.println("s name:" + this.soundFileName);
	pw.println(gainStart);
	pw.println(gainMid);
	pw.println(gainEnd);
	pw.println(panStart);
	pw.println(panMid);
	pw.println(panEnd);
	pw.println(soundFileName);
	pw.println(segmented);
	pw.println(threshSlider);
	pw.println(noiseSlider);
	pw.println(wavFilter);
	pw.println(trigger);
	pw.println(trigVar);
	pw.println(duration);
	pw.println(durVar);
	pw.println(randWalk);
	pw.println("");
    }
}
    
