
package sound;
import  utilities.WavRoutines;
import  javax.sound.sampled.AudioSystem;
import  javax.sound.sampled.AudioFormat;
import  javax.sound.sampled.AudioInputStream;
import  javax.sound.sampled.AudioFileFormat;

import  java.io.ByteArrayInputStream;
import	java.io.File;
import	java.io.IOException;

/**
 * normalize a soundfile. 
 */

public class Normalize 
{

    // input signal 


    public static void main(String s[]) {

	AudioFormat   audioFormat;

	if (s.length > 0) {
	    
	    AudioInputStream	audioInputStream = null;
	    audioInputStream = WavRoutines.getAudioInputStream(s[0]);
	    audioFormat = audioInputStream.getFormat(); 
	    
	    int sizeInBytes = audioFormat.getSampleSizeInBits() / 8;
	    int numBytes = 0;

	    try {
                numBytes = audioInputStream.available();
            }
            catch (Exception e) {
                e.printStackTrace();
                System.exit(1);
            }
            int nSamples = numBytes / sizeInBytes;

            // I could just read these in one at a time, instead of
            // all at once.  Integrate into loop below. 
            byte[] inBytes = new byte[nSamples*sizeInBytes];
	    
	    try {	    
                audioInputStream.read(inBytes, 0, numBytes*sizeInBytes);
            }
            catch (Exception e) {
                e.printStackTrace();
                System.exit(1);
            }
	    
	    double[] dData = WavRoutines.getDoubleData(inBytes, audioFormat);
	    WavRoutines.normalize(dData);

	    WavRoutines.getByteData(dData, dData.length, inBytes, audioFormat);
	    
	    ByteArrayInputStream    bais = new ByteArrayInputStream(inBytes);
	    AudioInputStream        ais = new AudioInputStream(
						bais, audioFormat,
						inBytes.length / 
						audioFormat.getFrameSize());
	    
	    // make automatic? 
	    AudioFileFormat.Type targetType = AudioFileFormat.Type.WAVE;
	    
	    try
		{
		    AudioSystem.write(
				      ais,
				      targetType,
				      new File(s[0]));
		}
	    catch (IOException e)
		{
		    e.printStackTrace();
		}
	}
	else 
	    {
		System.out.println("Normalize: usage:");
		System.out.println("\tjava Normalize <soundfile.wav>");
		System.exit(1);
	}
    }
}
