package utilities;

import  cern.jet.random.engine.DRand;
import  cern.colt.Arrays;
    
/**
 * utilities for user testing.
 */
public class SampleWithoutReplacement 
{

    public static void main(String [] args) {
	DRand drand = new DRand(new java.util.Date());

	int [] testy = new int[5];
	int [] testyOut;
	for (int i = 0; i < 5; i++ ) {
	    testy[i] = i;
	}

	for (int i = 0; i < 10; i ++) { 
	    testyOut = SampleWithoutReplacement.getVariation(testy, drand);
	    System.out.println(Arrays.toString(testyOut));
	}
	
    }

    public static int[]  getVariation(int [] ar, DRand drand) {
	int [] arr;
	int [] scratch;
	int [] result;

	scratch = new int[ar.length];
	result = new int[ar.length];
	System.arraycopy(ar, 0, scratch, 0, ar.length);         	

	int vars_left = ar.length;
	int index;
	float start;

	// want to sample without replacement. 
	for (int i = 0; i < ar.length; i++) {
	    
	    // pick a place at random from the scratch array
	    start    = drand.nextFloat();
	    index = (int)Math.floor(start*vars_left);
	    result[i] = scratch[index];
	    
	    // compact scratch	    
	    compactArray(scratch, index, vars_left);
	    vars_left--;
	}
	return result;
    }
	
    public static void compactArray(int[] ar, int index, int size)
    {
	if (size > ar.length) {
	    size = ar.length;
	}
	
	for (int i = index+1; i< size; i++ ) {
	    ar[i-1] = ar[i];
	}
    }
    /*
    int findnth(int nth) {
	int i = 0;
	
	for (int j = 0; j < nth; j++) {  
	    while (i < arr.length) && (arr[i] == 0) {
		i++;
	    }
	    if ( i == arr.length) {
		return -1;
	    }
	    j++;
	}
	return i;
    }



    int findNext() {
	int i = 0;
	while (arr[i] == 0) {
	    i++;
	}
	return i;
    }

    */
}
