package wavelet;
import  java.io.*;

/**
 * transitions records the difference between each window. 
 *
 */
public class Transitions implements Serializable
{
    public double [] trans;

    // energies records the energy of each level of the wavelet coefs 
    // for each window energies[windowNumber][waveletLevel]    
    double [][] energies;
    double [] avgEnergies;
    double [] avgAmp;
    
    public double min = 100;
    public double max = 0;

    /** 
     * deletes current data in transition object
     */
    public void blank() 
    {
	trans = null;
	energies = null;	
    }

    /** 
     * returns the avg energy for this frame.
     */
    public double getAvgEnergy(int frameIndex) {
	return avgEnergies[frameIndex];
    }

    /** 
     * returns the avg amplitude for this frame.
     */
    public double getAvgAmp(int frameIndex) {
	return avgAmp[frameIndex];
    }

    /** 
     * constructor
     * @param numWindows number of windows 
     * @param wavLevels  number of levels in the wavelet transform
     */
    public Transitions(int numWindows, int wavLevels) {
	trans = new double[numWindows-1];
	energies = new double[numWindows][wavLevels];
	avgEnergies = new double[numWindows];
	avgAmp = new double[numWindows];
    }
   
    /**
     * return the length of transitions array -- the number of transitions
     */
    public int length() {
	if (trans != null) {
	    return trans.length;
	}
	else return 0;
    }
}
    
    
